<?php
global $wpdb;
?>
<div class="wopgld-post-option-wrap">
    <label for="wopgld-show-custom-query" class="wopgld-custom-relation">
        <?php _e( 'Filter Custom Field Post', WOPGLD_TD ); ?>
    </label>
    <div class="wopgld-post-field-wrap">
        <label class="wopgld-switch">
            <input type="checkbox" class="wopgld-fetch-custom-field-post wopgld-checkbox" value="<?php
            if ( isset( $wopgld_option[ 'wopgld_show_custom_query' ] ) ) {
                echo esc_attr( $wopgld_option[ 'wopgld_show_custom_query' ] );
            } else {
                echo '0';
            }
            ?>" name="wopgld_option[wopgld_show_custom_query]" <?php if ( isset( $wopgld_option[ 'wopgld_show_custom_query' ] ) && $wopgld_option[ 'wopgld_show_custom_query' ] == '1' ) { ?>checked="checked"<?php } ?>/>
            <div class="wopgld-slider round"></div>
        </label>
        <p class="description"> <?php _e( 'Enable to show product associated with a certain custom field.', WOPGLD_TD ) ?></p>
    </div>
</div>
<div class="wopgld-custom-field-wrapper" <?php if ( isset( $wopgld_option[ 'wopgld_show_custom_query' ] ) && $wopgld_option[ 'wopgld_show_custom_query' ] == '1' ) { ?>
         style="display: block;" <?php } else { ?>
         style="display: none;" <?php } ?>>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Custom Field Query Types', WOPGLD_TD ); ?></label>
        <div class="wopgld-tooltip-icon">
            <span class="dashicons dashicons-info"></span>
            <span class="wopgld-tooltip-info">
                <ul>
                    <li>
                        <?php _e( "Single Custom Field Handling: Display product where the meta key is 'price' and the meta value that is LESS THAN OR EQUAL TO 22", WOPGLD_TD ); ?>

                    </li>
                    <li>
                        <?php _e( "Multiple Custom Field Handling: Display products that have meta key 'color' NOT LIKE value 'blue' OR meta key 'price' with values BETWEEN 20 and 100", WOPGLD_TD ); ?>

                    </li>
                </ul>
            </span>
        </div>
        <div class="wopgld-post-field-wrap">
            <select name="wopgld_option[wopgld_custom_field_type]" class="wopgld-custom-field-type">
                <option value="single_field"  <?php if ( isset( $wopgld_option[ 'wopgld_custom_field_type' ] ) && $wopgld_option[ 'wopgld_custom_field_type' ] == 'single_field' ) echo 'selected == "selected"'; ?>><?php _e( 'Single Custom Field Handling', WOPGLD_TD ) ?></option>
                <option value="multiple_field"  <?php if ( isset( $wopgld_option[ 'wopgld_custom_field_type' ] ) && $wopgld_option[ 'wopgld_custom_field_type' ] == 'multiple_field' ) echo 'selected == "selected"'; ?>><?php _e( 'Multiple Custom Field Handling', WOPGLD_TD ) ?></option>
            </select>

        </div>
    </div>
    <div class="wopgld-meta-key-wrap">
        <div class = "wopgld-post-option-wrap">
            <label><?php _e( 'Meta Keys', WOPGLD_TD ); ?></label>
            <div class="wopgld-post-field-wrap">
                <label><input type="radio" value="pre-available" name="wopgld_option[meta_keys_type]" <?php
                    if ( isset( $wopgld_option[ 'meta_keys_type' ] ) ) {
                        checked( $wopgld_option[ 'meta_keys_type' ], 'pre-available' );
                    }
                    ?> class="wopgld-meta-key-type"/><?php _e( "Pre Available Meta Keys", WOPGLD_TD ); ?></label>
                <label><input type="radio" value="other" name="wopgld_option[meta_keys_type]" <?php
                    if ( isset( $wopgld_option[ 'meta_keys_type' ] ) ) {
                        checked( $wopgld_option[ 'meta_keys_type' ], 'other' );
                    }
                    ?>  class="wopgld-meta-key-type"/><?php _e( 'Other Meta Keys', WOPGLD_TD ); ?></label>
                <div class="wopgld-other-meta-wrap" <?php if ( isset( $wopgld_option[ 'meta_keys_type' ] ) && $wopgld_option[ 'meta_keys_type' ] == 'pre-available' ) { ?> style="display: none;" <?php } ?>>
                    <input type="text" class="wopgld-other-meta-key" placeholder="<?php _e( 'Enter meta key', WOPGLD_TD ); ?>" name="wopgld_option[wopgld_other_meta_key]"  value="<?php
                    if ( isset( $wopgld_option[ 'wopgld_other_meta_key' ] ) ) {
                        echo $wopgld_option[ 'wopgld_other_meta_key' ];
                    }
                    ?>"/>
                </div>
                <div class="wopgld-pre-meta-key-wrap" <?php if ( isset( $wopgld_option[ 'meta_keys_type' ] ) && $wopgld_option[ 'meta_keys_type' ] == 'other' ) { ?> style="display:none;" <?php } ?>>
                    <?php
                    $post_meta_table = $wpdb -> postmeta;
                    $meta_keys = $wpdb -> get_results( "SELECT DISTINCT(meta_key) FROM $post_meta_table" );
                    ?>
                    <select class="wopgld-pre-metakey" name="wopgld_option[pre_meta_key]">
                        <option value=""><?php _e( 'None' ); ?></option>
                        <?php
                        foreach ( $meta_keys as $meta_key ) {
                            ?>
                            <option value="<?php echo $meta_key -> meta_key; ?>"  <?php if ( isset( $wopgld_option[ 'pre_meta_key' ] ) && $wopgld_option[ 'pre_meta_key' ] == $meta_key -> meta_key ) echo 'selected == "selected"'; ?>><?php echo $meta_key -> meta_key; ?></option>
                            <?php
                        }
                        ?>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Meta Value Type', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <select name="wopgld_option[wopgld_meta_value_type]" class="wopgld-meta-value-type">
                <option value="string"  <?php if ( isset( $wopgld_option[ 'wopgld_meta_value_type' ] ) && $wopgld_option[ 'wopgld_meta_value_type' ] == 'string' ) echo 'selected=="selected"'; ?>><?php _e( 'String', WOPGLD_TD ) ?></option>
                <option value="number"  <?php if ( isset( $wopgld_option[ 'wopgld_meta_value_type' ] ) && $wopgld_option[ 'wopgld_meta_value_type' ] == 'number' ) echo 'selected=="selected"'; ?>><?php _e( 'Number', WOPGLD_TD ) ?></option>
            </select>
        </div>
    </div>
    <div class="wopgld-meta-value-wrap">
        <div class ="wopgld-post-option-wrap">
            <label><?php _e( 'Enter Meta Value', WOPGLD_TD ); ?></label>
            <div class="wopgld-post-field-wrap">
                <input type="text" class="wopgld-meta-value"  name="wopgld_option[wopgld_meta_value]"  value="<?php
                if ( isset( $wopgld_option[ 'wopgld_meta_value' ] ) ) {
                    echo esc_attr( $wopgld_option[ 'wopgld_meta_value' ] );
                }
                ?>"/>
                <p class="description"><?php _e( "Please leave empty if don't need to filter from meta value", WOPGLD_TD ); ?></p>
            </div>
        </div>
    </div>
    <div class="wopgld-meta-number-wrap" style="display:none;">
        <div class ="wopgld-post-option-wrap">
            <label><?php _e( 'Meta Value Number', WOPGLD_TD ); ?></label>
            <div class="wopgld-post-field-wrap">
                <input type="number" min="1" class="wopgld-meta-value-number"  name="wopgld_option[wopgld_meta_value_number]"  value="<?php
                if ( isset( $wopgld_option[ 'wopgld_meta_value_number' ] ) ) {
                    echo $wopgld_option[ 'wopgld_meta_value_number' ];
                }
                ?>"/>
                <p class="description"><?php _e( "Please leave empty if don't need to filter from meta value number", WOPGLD_TD ); ?></p>
            </div>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Compare', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <select name="wopgld_option[wopgld_compare_operator]" class="wopgld-compare-post">
                <option value="="  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '=' ) echo 'selected=="selected"'; ?>><?php _e( 'Equal To', WOPGLD_TD ) ?></option>
                <option value="!="  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '!=' ) echo 'selected=="selected"'; ?>><?php _e( 'Not Equal To', WOPGLD_TD ) ?></option>
                <option value=">"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '>' ) echo 'selected=="selected"'; ?>><?php _e( 'Greater Than', WOPGLD_TD ) ?></option>
                <option value=">="  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '>=' ) echo 'selected=="selected"'; ?>><?php _e( 'Greater Than Equal To', WOPGLD_TD ) ?></option>
                <option value="<"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '<' ) echo 'selected=="selected"'; ?>><?php _e( 'Smaller Than', WOPGLD_TD ) ?></option>
                <option value="<="  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == '<=' ) echo 'selected=="selected"'; ?>><?php _e( 'Smaller Than Equal To', WOPGLD_TD ) ?></option>
                <option value="LIKE"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'LIKE' ) echo 'selected=="selected"'; ?>><?php _e( 'Like', WOPGLD_TD ) ?></option>
                <option value="NOT LIKE"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'NOT LIKE' ) echo 'selected=="selected"'; ?>><?php _e( 'Not Like', WOPGLD_TD ) ?></option>
                <option value="IN"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'IN' ) echo 'selected=="selected"'; ?>><?php _e( 'In', WOPGLD_TD ) ?></option>
                <option value="NOT IN"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'NOT IN' ) echo 'selected=="selected"'; ?>><?php _e( 'Not In', WOPGLD_TD ) ?></option>
                <option value="BETWEEN"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'BETWEEN' ) echo 'selected=="selected"'; ?>><?php _e( 'Between', WOPGLD_TD ) ?></option>
                <option value="NOT BETWEEN"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'NOT BETWEEN' ) echo 'selected=="selected"'; ?>><?php _e( 'Not Between', WOPGLD_TD ) ?></option>
                <option value="EXISTS"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'EXISTS' ) echo 'selected=="selected"'; ?>><?php _e( 'Exists', WOPGLD_TD ) ?></option>
                <option value="NOT EXISTS"  <?php if ( isset( $wopgld_option[ 'wopgld_compare_operator' ] ) && $wopgld_option[ 'wopgld_compare_operator' ] == 'NOT EXISTS' ) echo 'selected=="selected"'; ?>><?php _e( 'Not Exists', WOPGLD_TD ) ?></option>
            </select>
        </div>
    </div>
    <div class="wopgld-multiple-custom-field-wrap" style="display: none;">
        <div class ="wopgld-post-option-wrap">
            <label for="wopgld-show-relation-blogs" class="wopgld-relation-bogs">
                <?php _e( 'Relation', WOPGLD_TD ); ?>
            </label>
            <div class="wopgld-post-field-wrap">
                <label class="wopgld-switch">
                    <input type="checkbox" class="wopgld-show-custom-relation wopgld-checkbox" value="<?php
                    if ( isset( $wopgld_option[ 'wopgld_show_custom_relation' ] ) ) {
                        echo esc_attr( $wopgld_option[ 'wopgld_show_custom_relation' ] );
                    } else {
                        echo 0;
                    }
                    ?>" name="wopgld_option[wopgld_show_custom_relation]" <?php if ( isset( $wopgld_option[ 'wopgld_show_custom_relation' ] ) && $wopgld_option[ 'wopgld_show_custom_relation' ] == '1' ) { ?>checked="checked"<?php } ?>/>
                    <div class="wopgld-slider round"></div>
                </label>
                <p class="description"> <?php _e( 'Enable to show relation between meta queries', WOPGLD_TD ) ?></p>
            </div>
        </div>
        <div class="wopgld-relation-main-wrap" <?php if ( isset( $wopgld_option[ 'wopgld_show_custom_relation' ] ) && $wopgld_option[ 'wopgld_show_custom_relation' ] == '1' ) { ?> style="display: block;" <?php } else { ?>  style="display: none;" <?php } ?>>
            <div class ="wopgld-post-option-wrap">
                <label><?php _e( 'Relation', WOPGLD_TD ); ?></label>
                <div class="wopgld-post-field-wrap">
                    <select name="wopgld_option[wopgld_relation_field]" class="wopgld-relation-field">
                        <option value="AND"  <?php if ( isset( $wopgld_option[ 'wopgld_relation_field' ] ) && $wopgld_option[ 'wopgld_relation_field' ] == 'AND' ) echo 'selected=="selected"'; ?>><?php _e( 'AND', WOPGLD_TD ) ?></option>
                        <option value="OR"  <?php if ( isset( $wopgld_option[ 'wopgld_relation_field' ] ) && $wopgld_option[ 'wopgld_relation_field' ] == 'OR' ) echo 'selected=="selected"'; ?>><?php _e( 'OR', WOPGLD_TD ) ?></option>
                    </select>
                </div>
            </div>
        </div>
        <div class="wopgld-custom-field-inner-wrap">
            <?php
            if ( isset( $wopgld_option[ 'wopgld_custom' ] ) && is_array( $wopgld_option[ 'wopgld_custom' ] ) ) {
                $wopgld_custom_count = count( $wopgld_option[ 'wopgld_custom' ] );
            } else {
                $wopgld_custom_count = 0;
            }
            if ( $wopgld_custom_count > 0 ) {

                foreach ( $wopgld_option[ 'wopgld_custom' ] as $custom_key => $custom_detail ) {
                    include(WOPGLD_PATH . 'inc/admin/forms/wopgld-blog-detail.php');
                }
            }
            ?>
        </div>
        <div class="wopgld-query-button">
            <input type="button" class="button-primary wopgld-add-meta-query" value="<?php _e( 'Add New Meta Condition', WOPGLD_TD ); ?>">
        </div>
    </div>
</div>