<?php
defined( 'ABSPATH' ) or die( "No script kiddies please!" );
$name_prefix = "wopgld_option[wopgld_blog][$blog_key]";
$value_prefix = $wopgld_option[ 'wopgld_blog' ][ $blog_key ];
?>
<div class="wopgld-each-taxonomy-wrap">
    <div class="wopgld-delete-query">
        <span class="dashicons dashicons-trash"></span>
    </div>
    <div class="wopgld-post-option-wrap">
        <label><?php _e( 'Taxonomy/Category', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <select name="<?php echo esc_attr( $name_prefix . '[multiple_post_taxonomy]' ); ?>" class="wopgld-multiple-taxonomy">
                <option value=""><?php echo _e( 'Choose Taxonomy', WOPGLD_TD ); ?></option>
                <?php
                $product_post_type = 'product';
                $taxonomies = get_object_taxonomies( $product_post_type, 'objects' );
                foreach ( $taxonomies as $tax ) {
                    $value = $tax -> name;
                    $label = $tax -> label;
                    ?>
                    <option value="<?php echo $value; ?>" <?php if ( isset( $value_prefix[ 'multiple_post_taxonomy' ] ) && $value_prefix[ 'multiple_post_taxonomy' ] == $value ) echo 'selected=="selected"'; ?>><?php echo $label; ?></option>
                    <?php
                }
                ?>
            </select>
            <p class="description"><?php _e( 'Please select the product type first', WOPGLD_TD ); ?></p>
        </div>
    </div>
    <div class="wopgld-post-option-wrap">
        <label><?php _e( 'Terms', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap wopgld-multiple-select">
            <select name="<?php echo esc_attr( $name_prefix . '[multiple_taxonomy_terms][]' ); ?>" multiple="multiple" class="wopgld-hierarchy-taxonomy-term">
                <option value=""><?php echo 'Choose Terms'; ?></option>
                <?php
                $select_tax = $value_prefix[ 'multiple_post_taxonomy' ];
                if ( isset( $value_prefix[ 'multiple_post_taxonomy' ] ) ) {
                    echo $this -> wopgld_fetch_category_list( $select_tax, $value_prefix[ 'multiple_taxonomy_terms' ] );
                }
                ?>
            </select>
        </div>
    </div>
    <div class="wopgld-post-option-wrap">
        <label for="wopgld-enable-operator" class="wopgld-enable-operator">
            <?php _e( 'Operator', WOPGLD_TD ); ?>
        </label>
        <div class="wopgld-post-field-wrap">
            <label class="wopgld-switch">
                <input type="checkbox" class="wopgld-show-operator wopgld-checkbox" value="<?php
                if ( isset( $value_prefix[ 'wopgld_enable_operator' ] ) ) {
                    echo esc_attr( $value_prefix[ 'wopgld_enable_operator' ] );
                } else {
                    echo '0';
                }
                ?>" name="<?php echo esc_attr( $name_prefix . '[wopgld_enable_operator]' ); ?>" <?php if ( isset( $value_prefix[ 'wopgld_enable_operator' ] ) && $value_prefix[ 'wopgld_enable_operator' ] == '1' ) { ?>checked="checked"<?php } ?>/>
                <div class="wopgld-slider round"></div>
            </label>
            <p class="description"> <?php _e( 'Enable operator to test and filter the post', WOPGLD_TD ) ?></p>
            <div class="wopgld-operator-inner-wrap" <?php if ( isset( $value_prefix[ 'wopgld_enable_operator' ] ) && $value_prefix[ 'wopgld_enable_operator' ] == '1' ) { ?> style="display: block;" <?php } else { ?> style="display: none;" <?php } ?>>
                <select name="<?php echo esc_attr( $name_prefix . '[wopgld_terms_operator]' ); ?>" class="wopgld-terms-operator">
                    <option value="IN" <?php if ( isset( $value_prefix[ 'wopgld_terms_operator' ] ) && $value_prefix[ 'wopgld_terms_operator' ] == 'IN' ) echo 'selected=="selected"'; ?>><?php _e( 'IN', WOPGLD_TD ) ?></option>
                    <option value="NOT IN" <?php if ( isset( $value_prefix[ 'wopgld_terms_operator' ] ) && $value_prefix[ 'wopgld_terms_operator' ] == 'NOT IN' ) echo 'selected=="selected"'; ?>><?php _e( 'NOT IN', WOPGLD_TD ) ?></option>
                    <option value="AND" <?php if ( isset( $value_prefix[ 'wopgld_terms_operator' ] ) && $value_prefix[ 'wopgld_terms_operator' ] == 'AND' ) echo 'selected=="selected"'; ?>><?php _e( 'AND', WOPGLD_TD ) ?></option>
                    <option value="EXISTS" <?php if ( isset( $value_prefix[ 'wopgld_terms_operator' ] ) && $value_prefix[ 'wopgld_terms_operator' ] == 'EXISTS' ) echo 'selected=="selected"'; ?>><?php _e( 'EXISTS', WOPGLD_TD ) ?></option>
                    <option value="NOT EXISTS" <?php if ( isset( $value_prefix[ 'wopgld_terms_operator' ] ) && $value_prefix[ 'wopgld_terms_operator' ] == 'NOT EXISTS' ) echo 'selected=="selected"'; ?>><?php _e( 'NOT EXISTS', WOPGLD_TD ) ?></option>
                </select>
            </div>
        </div>
    </div>
</div>