<?php

class WOPGLD_VC_Elements extends WPBakeryShortCode{

    // Element Init
    function __construct(){
        add_action( 'init', array( $this, 'wopgld_vc_widgets' ) );
        add_shortcode( 'wpbm', array( $this, 'wopgld_vc_shortcode' ) );
    }

    function wopgld_vc_widgets(){
        // Stop all if VC is not enabled
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
        //Require new custom Element
        $args = array(
            'post_type' => 'woo_product_design',
            'post_status' => 'publish',
            'posts_per_page' => -1,
            'order' => 'ASC',
            'orderby' => 'id'
        );
        $posts = get_posts( $args );
        if ( ! empty( $posts ) ) {
            foreach ( $posts as $post ) {
                $wopgld_post_types[ $post -> post_title ] = $post -> ID;
            }
        } else {
            $wopgld_post_types[ __( 'No product grid list design data found.', WOPGLD_TD ) ] = '';
        }

        vc_map( array(
            'name' => 'WOO Product Grid List Design Widget',
            'base' => 'wopgld',
            'description' => esc_html__( 'Products Showcase Extension for Woocommerce', WOPGLD_TD ),
            'category' => 'WOO Product Grid List Design',
            'icon' => '',
            'params' => array(
                array(
                    'type' => 'dropdown',
                    'heading' => esc_html__( 'WOO Product Grid List Design', WOPGLD_TD ),
                    'param_name' => 'id',
                    'class' => 'wopgld-lists',
                    'save_always' => true,
                    'value' => $wopgld_post_types,
                    'description' => esc_html__( 'Select any woo product grid list design post title and add it to your post or page.', WOPGLD_TD ),
                )
            )
        ) );
    }

    // Element HTML
    public function wopgld_vc_shortcode( $atts, $content = null ){

        ob_start();
        include('inc/frontend/wopgld-frontend.php');
        $blog = ob_get_contents();
        ob_end_clean();
        return $blog;
    }

}

new WOPGLD_VC_Elements();
