<?php
defined( 'ABSPATH' ) or die( "No script kiddies please!" );
$key = $this -> wopgld_generate_random_string( 15 );
$custom_key = 'custom_' . $key;
$custom_prefix = "wopgld_option[wopgld_custom][$custom_key]";
?>
<div class="wopgld-each-meta-container-wrap">
    <div class="wopgld-delete-meta-query">
        <span class="dashicons dashicons-trash"></span>
    </div>
    <div class = "wopgld-post-option-wrap">
        <label><?php _e( 'Meta Keys', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <label><input type="radio" value="pre-available" name="<?php echo esc_attr( $custom_prefix . '[multiple_meta_key_type]' ); ?>" class="wopgld-multiple-meta-keys"/><?php _e( "Pre Available Meta Keys", WOPGLD_TD ); ?></label>
            <label><input type="radio" value="other" name="<?php echo esc_attr( $custom_prefix . '[multiple_meta_key_type]' ); ?>" class="wopgld-multiple-meta-keys"/><?php _e( 'Other Meta Keys', WOPGLD_TD ); ?></label>
            <div class ="wopgld-pre-multiple-key-wrap" style="display: none;">
                <?php
                $post_meta_table = $wpdb -> postmeta;
                $meta_keys = $wpdb -> get_results( "SELECT DISTINCT(meta_key) FROM $post_meta_table" );
                ?>
                <select class="wopgld-pre-multiple-metakey" name="<?php echo esc_attr( $custom_prefix . '[wopgld_pre_multiple_meta_key]' ); ?>">
                    <option value=""><?php _e( 'None' ); ?></option>
                    <?php
                    foreach ( $meta_keys as $meta_key ) {
                        ?>
                        <option value="<?php echo $meta_key -> meta_key; ?>"><?php echo $meta_key -> meta_key; ?></option>
                        <?php
                    }
                    ?>
                </select>
            </div>
            <div class="wopgld-multiple-other-key-wrap" style="display: none;">
                <input type="text" class="wopgld-multiple-other-key"  name="<?php echo esc_attr( $custom_prefix . '[wopgld_multiple_other_key]' ); ?>"  value=""/>
            </div>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Meta Value', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <input type="text" class="wopgld-multiple-meta-value"  name="<?php echo esc_attr( $custom_prefix . '[wopgld_multiple_meta_value]' ); ?>"  value=""/>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Compare', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <select name="<?php echo esc_attr( $custom_prefix . '[wopgld_compare_operator]' ); ?>" class="wopgld-compare-post">
                <option value="="><?php _e( 'Equal To', WOPGLD_TD ) ?></option>
                <option value="!="><?php _e( 'Not Equal To', WOPGLD_TD ) ?></option>
                <option value=">"><?php _e( 'Greater Than', WOPGLD_TD ) ?></option>
                <option value=">="><?php _e( 'Greater Than Equal To', WOPGLD_TD ) ?></option>
                <option value="<"><?php _e( 'Smaller Than', WOPGLD_TD ) ?></option>
                <option value="<="><?php _e( 'Smaller Than Equal To', WOPGLD_TD ) ?></option>
                <option value="LIKE"><?php _e( 'Like', WOPGLD_TD ) ?></option>
                <option value="NOT LIKE"><?php _e( 'Not Like', WOPGLD_TD ) ?></option>
                <option value="IN"><?php _e( 'In', WOPGLD_TD ) ?></option>
                <option value="NOT IN"><?php _e( 'Not In', WOPGLD_TD ) ?></option>
                <option value="BETWEEN"><?php _e( 'Between', WOPGLD_TD ) ?></option>
                <option value="NOT BETWEEN"><?php _e( 'Not Between', WOPGLD_TD ) ?></option>
                <option value="EXISTS"><?php _e( 'Exists', WOPGLD_TD ) ?></option>
                <option value="NOT EXISTS"><?php _e( 'Not Exists', WOPGLD_TD ) ?></option>
            </select>
        </div>
    </div>
    <div class="wopgld-custom-type-main-wrap">
        <div class ="wopgld-post-option-wrap">
            <label for="wopgld-show-type-check" class="wopgld-show-type">
                <?php _e( 'Type', WOPGLD_TD ); ?>
            </label>
            <div class="wopgld-post-field-wrap">
                <label class="wopgld-switch">
                    <input type="checkbox" class="wopgld-show-type-filter wopgld-checkbox" value="0" name="<?php echo esc_attr( $custom_prefix . '[wopgld_show_type_filter]' ); ?>"/>
                    <div class="wopgld-slider round"></div>
                </label>
                <p class="description"> <?php _e( 'Enable to filter logo by custom field type', WOPGLD_TD ) ?></p>
                <div class="wopgld-type-filter-wrap" style="display: none;">
                    <select name="<?php echo esc_attr( $custom_prefix . '[wopgld_field_compare_type]' ); ?>" class="wopgld-field-compare-type">
                        <option value="NUMERIC"><?php _e( 'Numeric', WOPGLD_TD ) ?></option>
                        <option value="BINARY"><?php _e( 'Binary', WOPGLD_TD ) ?></option>
                        <option value="CHAR"><?php _e( 'Char', WOPGLD_TD ) ?></option>
                        <option value="DATETIME"><?php _e( 'Date Time', WOPGLD_TD ) ?></option>
                        <option value="DECIMAL"><?php _e( 'Decimal', WOPGLD_TD ) ?></option>
                        <option value="SIGNED"><?php _e( 'Signed', WOPGLD_TD ) ?></option>
                        <option value="TIME"><?php _e( 'Time', WOPGLD_TD ) ?></option>
                        <option value="UNSIGNED"><?php _e( 'Unsigned', WOPGLD_TD ) ?></option>
                    </select>
                </div>
            </div>
        </div>
    </div>
</div>