<?php
defined( 'ABSPATH' ) or die( "No script kiddies please!" );
$post_type = 'product';
$key = $this -> wopgld_generate_random_string( 15 );
$blog_key = 'blog_' . $key;
$blog_prefix = "wopgld_option[wopgld_blog][$blog_key]";
?>
<div class="wopgld-each-taxonomy-wrap">
    <div class="wopgld-delete-query">
        <span class="dashicons dashicons-trash"></span>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Taxonomy/Category', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap">
            <select name="<?php echo esc_attr( $blog_prefix . '[multiple_post_taxonomy]' ); ?>" class="wopgld-multiple-taxonomy">
                <option value="select" ><?php echo _e( 'Choose Taxonomy', WOPGLD_TD ); ?></option>
                <?php
                $taxonomies = get_object_taxonomies( $post_type, 'objects' );
                foreach ( $taxonomies as $tax ) {
                    $value = $tax -> name;
                    $label = $tax -> label;
                    ?>
                    <option value="<?php echo $value; ?>"><?php echo $label; ?></option>
                    <?php
                }
                ?>
            </select>
            <p class="description"><?php _e( 'Please select the product type first', WOPGLD_TD ); ?></p>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label><?php _e( 'Terms', WOPGLD_TD ); ?></label>
        <div class="wopgld-post-field-wrap wopgld-multiple-select">
            <select name="<?php echo esc_attr( $blog_prefix . '[multiple_taxonomy_terms][]' ); ?>" multiple="multiple" class="wopgld-hierarchy-taxonomy-term">
                <option value="" ><?php echo _e( 'Select Taxonomy First', WOPGLD_TD ); ?></option>
            </select>
        </div>
    </div>
    <div class ="wopgld-post-option-wrap">
        <label for="wopgld-enable-operator" class="wopgld-enable-operator">
            <?php _e( 'Operator', WOPGLD_TD ); ?>
        </label>
        <div class="wopgld-post-field-wrap">
            <label class="wopgld-switch">
                <input type="checkbox" class="wopgld-show-operator wopgld-checkbox" value="0" name="<?php echo esc_attr( $blog_prefix . '[wopgld_enable_operator]' ); ?>"/>
                <div class="wopgld-slider round"></div>
            </label>
            <p class="description"> <?php _e( 'Enable operator to test and filter the post', WOPGLD_TD ) ?></p>
            <div class="wopgld-operator-inner-wrap" style="display: none;">
                <select name="<?php echo esc_attr( $blog_prefix . '[wopgld_terms_operator]' ); ?>" class="wopgld-terms-operator">
                    <option value="IN"><?php _e( 'IN', WOPGLD_TD ) ?></option>
                    <option value="NOT IN"><?php _e( 'NOT IN', WOPGLD_TD ) ?></option>
                    <option value="AND"><?php _e( 'AND', WOPGLD_TD ) ?></option>
                    <option value="EXISTS"><?php _e( 'EXISTS', WOPGLD_TD ) ?></option>
                    <option value="NOT EXISTS"><?php _e( 'NOT EXISTS', WOPGLD_TD ) ?></option>
                </select>
            </div>
        </div>
    </div>
</div>