<?php
if ( isset( $wopgld_option[ 'wopgld_display_pagination' ] ) && $wopgld_option[ 'wopgld_display_pagination' ] == 1 ) {

    $per_page = ($wopgld_option[ 'wopgld_post_number' ] == '') ? 1 : esc_attr( $wopgld_option[ 'wopgld_post_number' ] );
    $total_items = $rowCount;
    $total_page = $total_items / $per_page;
    if ( $total_items % $per_page != 0 ) {
        $total_page = intval( $total_page ) + 1;
    }

    if ( $wopgld_option[ 'wopgld_select_pagination' ] == 'standard_pagination' ) {
        $pagination_layout_class = isset( $wopgld_option[ 'wopgld_standard_page_template' ] ) ? 'wopgld-standard-page-' . esc_attr( $wopgld_option[ 'wopgld_standard_page_template' ] ) : 'wopgld-standard-page-template-1';
        $upper_limit = ($total_page <= 5) ? $total_page : 5;
        if ( isset( $wopgld_option[ 'wopgld_standard_page_template' ] ) && $wopgld_option[ 'wopgld_standard_page_template' ] == 'template-1' ) {
            $next_arrow = "<i class='fa fa-angle-double-right' aria-hidden='true'></i>";
            $prev_arrow = "<i class='fa fa-angle-double-left' aria-hidden='true'></i>";
        } else if ( isset( $wopgld_option[ 'wopgld_standard_page_template' ] ) && $wopgld_option[ 'wopgld_standard_page_template' ] == 'template-2' ) {
            $next_arrow = "<i class='fa fa-arrow-right' aria-hidden='true'></i>";
            $prev_arrow = "<i class='fa fa-arrow-left' aria-hidden='true'></i>";
        } else if ( isset( $wopgld_option[ 'wopgld_standard_page_template' ] ) && $wopgld_option[ 'wopgld_standard_page_template' ] == 'template-3' ) {
            $next_arrow = 'Next';
            $prev_arrow = 'Previous';
        } else if ( isset( $wopgld_option[ 'wopgld_standard_page_template' ] ) && $wopgld_option[ 'wopgld_standard_page_template' ] == 'template-4' ) {
            $next_arrow = 'Next';
            $prev_arrow = 'Prev';
        } else {
            $next_arrow = "<i class='fa fa-long-arrow-right' aria-hidden='true'></i>";
            $prev_arrow = "<i class='fa fa-long-arrow-left' aria-hidden='true'></i>";
        }
        ?>
        <div class="wopgld-pagination-block <?php echo $pagination_layout_class; ?>">
            <ul class="wopgld-inner-paginate">
                <?php
                for ( $l = 1; $l <= $upper_limit; $l ++ ) {
                    ?>
                    <li><a href="javascript:void(0);" data-total-page="<?php echo $total_page; ?>" data-layout-type="<?php echo esc_attr( $wopgld_option[ 'wopgld_select_layout' ] ); ?>" data-post-id="<?php echo $post_id; ?>" data-page-number="<?php echo $l; ?>" data-next-arrow="<?php echo $next_arrow; ?>" data-prev-arrow="<?php echo $prev_arrow; ?>" class= "<?php echo ($l == 1) ? 'wopgld-current-page' : ''; ?> wopgld-page-link"><?php echo $l; ?></a></li>
                    <?php
                }
                ?>
                <li class="wopgld-next-page-wrap"><a href="javascript:void(0);" data-total-page="<?php echo $total_page; ?>" data-layout-type="<?php echo esc_attr( $wopgld_option[ 'wopgld_select_layout' ] ); ?>" data-post-id="<?php echo $post_id; ?>" data-page-number="2" data-next-arrow="<?php echo $next_arrow; ?>" data-prev-arrow="<?php echo $prev_arrow; ?>" class="wopgld-next-page"><?php echo $next_arrow; ?></a></li>
            </ul>
            <img src="<?php echo WOPGLD_IMG_DIR . '/ajax-loader-add.gif'; ?>" class="wopgld-ajax-loader" style="display:none;"/>
        </div>
        <?php
    } else if ( $wopgld_option[ 'wopgld_select_pagination' ] == 'load_more_button' ) {
        $load_more_layout_class = isset( $wopgld_option[ 'wopgld_load_more_template' ] ) ? 'wopgld-load-more-' . esc_attr( $wopgld_option[ 'wopgld_load_more_template' ] ) : 'wopgld-load-more-template-1';
        ?>
        <div class="wopgld-load-more-block <?php echo $load_more_layout_class; ?>">
            <a class="wopgld-load-more-trigger" href="javascript:void(0);"
               data-page-number="1"
               data-layout-type="<?php echo $wopgld_option[ 'wopgld_select_layout' ]; ?>"
               data-post-id="<?php echo $post_id; ?>"
               data-total-page="<?php echo $total_page; ?>"
               >
                   <?php
                   if ( isset( $wopgld_option[ 'wopgld_load_more_template' ] ) && $wopgld_option[ 'wopgld_load_more_template' ] == 'template-4' ) {
                       ?>
                    <span class="wopgld-top"></span><?php echo ($wopgld_option[ 'wopgld_load_more_text' ] != '') ? esc_attr( $wopgld_option[ 'wopgld_load_more_text' ] ) : __( 'Load More', WOPGLD_TD ); ?><span class="wopgld-bottom"></span>

                    <?php
                } else {
                    echo ($wopgld_option[ 'wopgld_load_more_text' ] != '') ? esc_attr( $wopgld_option[ 'wopgld_load_more_text' ] ) : __( 'Load More', WOPGLD_TD );
                }
                ?>
            </a>
            <?php $loader = isset( $wopgld_option[ 'wopgld_loader_preview_type' ] ) ? esc_attr( $wopgld_option[ 'wopgld_loader_preview_type' ] ) : 'loader-1'; ?>
            <img src="<?php echo WOPGLD_IMG_DIR . '/loader/' . $loader . '.gif'; ?>" class="wopgld-ajax-loader" style="display:none;"/>
        </div>
        <?php
    } else {
        ?>
        <div class="wopgld-infinite-load">
            <a class="wopgld-infinite-load-trigger" href="javascript:void(0);"
               data-page-number="1"
               data-layout-type="<?php echo $wopgld_option[ 'wopgld_select_layout' ]; ?>"
               data-post-id="<?php echo $post_id; ?>"
               data-total-page="<?php echo $total_page; ?>"
               >
            </a>
            <?php $loader = isset( $wopgld_option[ 'wopgld_loader_preview_type' ] ) ? esc_attr( $wopgld_option[ 'wopgld_loader_preview_type' ] ) : 'loader-1'; ?>
            <img src="<?php echo WOPGLD_IMG_DIR . '/loader/' . $loader . '.gif'; ?>" class="wopgld-infinite-loader" style="display:none;"/>
        </div>
        <?php
    }
}