<?php
defined( 'ABSPATH' ) or die( "No script kiddies please!" );
/**
 * Plugin Name: WOO Product Grid/List Design
 * Plugin URI:  https://accesspressthemes.com/wordpress-plugins/woo-product-grid-list-design/
 * Description:  Plugin to Manage / Design WordPress Products Showcase | 40+ stunning, responsive, creative and powerful design.
 * Version:     1.0.2
 * Author:      20script
 * Author URI:  http://www.20script.ir/
 * Domain Path: /languages/
 * Text Domain: woo-product-grid-list-design
 * */
/**
 * Declaration of necessary constants for plugin
 * */
defined( 'WOPGLD_VERSION' ) or define( 'WOPGLD_VERSION', '1.0.2' ); //plugin version
defined( 'WOPGLD_TD' ) or define( 'WOPGLD_TD', 'woo-product-grid-list-design' ); //plugin's text domain
defined( 'WOPGLD_IMG_DIR' ) or define( 'WOPGLD_IMG_DIR', plugin_dir_url( __FILE__ ) . 'images' ); //plugin image directory
defined( 'WOPGLD_JS_DIR' ) or define( 'WOPGLD_JS_DIR', plugin_dir_url( __FILE__ ) . 'js' );  //plugin js directory
defined( 'WOPGLD_CSS_DIR' ) or define( 'WOPGLD_CSS_DIR', plugin_dir_url( __FILE__ ) . 'css' ); // plugin css dir
defined( 'WOPGLD_PATH' ) or define( 'WOPGLD_PATH', plugin_dir_path( __FILE__ ) );
defined( 'WOPGLD_URL' ) or define( 'WOPGLD_URL', plugin_dir_url( __FILE__ ) );
defined( 'PLUGIN_TEMPLATE_PATH' ) or define( 'PLUGIN_TEMPLATE_PATH', plugin_dir_path( __FILE__ ) . 'woocommerce' );

include(WOPGLD_PATH . '/inc/frontend/wopgld-mobile-detect.php');
if ( ! class_exists( 'WOPGLD_Class' ) ) {

    class WOPGLD_Class{

        /**
         * Initializes the plugin functions
         */
        function __construct(){

            add_action( 'init', array( $this, 'wopgld_plugin_text_domain' ) ); //loads text domain for translation ready
            add_action( 'wp_enqueue_scripts', array( $this, 'wopgld_register_assets' ) ); //registers scripts and styles for front end
            add_action( 'init', array( $this, 'wopgld_register_post_type' ) ); //register custom post type
            add_action( 'admin_enqueue_scripts', array( $this, 'wopgld_register_admin_assets' ) ); //register plugin scripts and css in wp-admin
            add_action( 'add_meta_boxes', array( $this, 'wopgld_add_blog_metabox' ) ); //added blog showcase metabox
            add_action( 'add_meta_boxes', array( $this, 'wopgld_shortcode_usage_metabox' ) ); //added shortcode usages metabox
            add_action( 'add_meta_boxes', array( $this, 'wopgld_banner_settings' ) ); //added blog showcase metabox
            add_action( 'add_meta_boxes', array( $this, 'wopgld_button_settings' ) ); //added blog showcase metabox
            add_action( 'save_post', array( $this, 'wopgld_meta_save' ) );
            add_action( 'save_post', array( $this, 'wopgld_advance_field_save' ) );
            add_action( 'wp_ajax_wopgld_slider_images', array( $this, 'wopgld_slider_images' ) );
            add_action( 'wp_ajax_wopgld_selected_taxonomy_terms', array( $this, 'wopgld_selected_taxonomy_terms' ) );
            add_action( 'wp_ajax_wopgld_hierarchy_terms', array( $this, 'wopgld_hierarchy_terms' ) );
            add_action( 'wp_ajax_wopgld_add_meta_condition', array( $this, 'wopgld_add_meta_condition' ) );
            add_action( 'wp_ajax_wopgld_add_tax_condition', array( $this, 'wopgld_add_tax_condition' ) );
            add_shortcode( 'wopgld', array( $this, 'wopgld_generate_shortcode' ) ); // generating shortcode
            add_filter( 'preview_post_link', array( $this, 'wopgld_preview_page' ), 10, 2 );
            add_action( 'wp_ajax_wopgld_filter_tax_terms', array( $this, 'wopgld_filter_tax_terms' ) );
            add_action( 'wp_ajax_wopgld_pagination_action', array( $this, 'wopgld_pagination_action' ) );
            add_action( 'wp_ajax_nopriv_wopgld_pagination_action', array( $this, 'wopgld_pagination_action' ) );
            add_action( 'template_redirect', array( $this, 'wopgld_preview_blog' ) );
            add_action( 'admin_menu', array( $this, 'wopgld_register_about_us_page' ) ); //add submenu page
            add_filter( 'post_row_actions', array( $this, 'wopgld_remove_row_actions' ), 10, 1 );
            add_filter( 'manage_woo_product_design_posts_columns', array( $this, 'wopgld_columns_head' ) );
            add_action( 'manage_woo_product_design_posts_custom_column', array( $this, 'wopgld_columns_content' ), 10, 2 );
            add_action( 'admin_head-post-new.php', array( $this, 'wopgld_posttype_admin_css' ) );
            add_action( 'admin_head-post.php', array( $this, 'wopgld_posttype_admin_css' ) );
            add_action( 'widgets_init', array( $this, 'wopgld_widget_register' ) );
            add_action( 'init', array( $this, 'wopgld_add_new_image_size' ) );
            add_action( 'wp_footer', array( $this, 'wopgld_add_lightbox_footer' ) );
            add_action( 'wp_ajax_nopriv_wopgld_view_lightbox', array( $this, 'wopgld_view_lightbox' ) );
            add_action( 'wp_ajax_wopgld_view_lightbox', array( $this, 'wopgld_view_lightbox' ) );
            add_action( 'wp_ajax_nopriv_wopgld_variable_attribute', array( $this, 'wopgld_variable_attribute' ) );
            add_action( 'wp_ajax_wopgld_variable_attribute', array( $this, 'wopgld_variable_attribute' ) );
//Ajax variable cart woocommerce
            // add_filter( 'woocommerce_get_sections_products', array( $this, 'wc_ajax_add_to_cart_variable_add_section' ) );
            //     add_filter( 'woocommerce_get_settings_products', array( $this, 'wc_ajax_add_to_cart_variable_all_settings' ), 10, 2 );
            add_action( 'wp_ajax_woocommerce_add_to_cart_variable_rc', array( $this, 'woocommerce_add_to_cart_variable_rc_callback' ) );
            add_action( 'wp_ajax_nopriv_woocommerce_add_to_cart_variable_rc', array( $this, 'woocommerce_add_to_cart_variable_rc_callback' ) );
            // add_action( 'admin_menu', array( $this, 'wopgld_register_settings_page' ) ); //add submenu page
            add_action( 'admin_post_wopgld_settings_save', array( $this, 'wopgld_save_form_settings' ) );
            add_action( 'vc_before_init', array( $this, 'wopgld_vc_integrate_widget' ) );
        }

//load the text domain for language translation
        function wopgld_plugin_text_domain(){
            load_plugin_textdomain( 'woo-product-grid-list-design', false, basename( dirname( __FILE__ ) ) . '/languages/' );
        }

//register admin assets
        function wopgld_register_admin_assets( $hook ){
            global $post;
            wp_enqueue_media();
            wp_enqueue_script( 'thickbox' );
            wp_enqueue_script( 'wp-color-picker' );
            wp_enqueue_script( 'jquery-ui-core' );
            wp_enqueue_script( 'wopgld-picker-script', WOPGLD_JS_DIR . '/icon-picker.js', array( 'jquery' ), WOPGLD_VERSION );
            wp_enqueue_script( 'wopgld-admin-script', WOPGLD_JS_DIR . '/wopgld-admin-script.js', array( 'jquery', 'wp-color-picker', 'jquery-ui-sortable', 'jquery-ui-core', 'wopgld-picker-script' ), WOPGLD_VERSION );
            $admin_ajax_nonce = wp_create_nonce( 'wopgld-admin-ajax-nonce' );
            $admin_ajax_object = array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'ajax_nonce' => $admin_ajax_nonce );
            wp_localize_script( 'wopgld-admin-script', 'wopgld_backend_js_params', $admin_ajax_object );
            wp_enqueue_style( 'thickbox' );
            wp_enqueue_style( 'wp-color-picker' );
            wp_enqueue_style( 'dashicons' );
            wp_enqueue_style( 'wopgld-icon-style', WOPGLD_CSS_DIR . '/icon-picker.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-font', WOPGLD_CSS_DIR . '/font-awesome.min.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-backend-style', WOPGLD_CSS_DIR . '/wopgld-backend-style.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-jquery-ui-style', WOPGLD_CSS_DIR . '/jquery-ui-css-1.12.1.css', false, WOPGLD_VERSION );
        }

//register frontend assests
        function wopgld_register_assets(){

            wp_enqueue_style( 'dashicons' );
            wp_enqueue_style( 'wopgld-bxslider-style', WOPGLD_CSS_DIR . '/jquery.bxslider.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-fontawesome', WOPGLD_CSS_DIR . '/font-awesome.min.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-font', '//fonts.googleapis.com/css?family=Bitter|Hind|Playfair+Display:400,400i,700,700i,900,900i|Open+Sans:400,500,600,700,900|Lato:300,400,700,900|Montserrat|Droid+Sans|Roboto|Lora:400,400i,700,700i|Roboto+Slab|Rubik|Merriweather:300,400,700,900|Poppins|Ropa+Sans|Playfair+Display|Rubik|Source+Sans+Pro|Roboto+Condensed|Roboto+Slab:300,400,700|Amatic+SC:400,700|Quicksand|Oswald|Quicksand:400,500,700', false );
            wp_enqueue_style( 'wopgld-animation-style', WOPGLD_CSS_DIR . '/animate.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-scroll-style', WOPGLD_CSS_DIR . '/jquery.mCustomScrollbar.css', false, WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-linear-style', WOPGLD_CSS_DIR . '/icon-font.min.css', false, WOPGLD_VERSION );

            wp_enqueue_style( 'wopgld-frontend-style', WOPGLD_CSS_DIR . '/wopgld-frontend.css', array( 'wopgld-bxslider-style', 'wopgld-font', 'wopgld-animation-style', 'wopgld-scroll-style', 'wopgld-linear-style' ), WOPGLD_VERSION );
            wp_enqueue_style( 'wopgld-responsive-style', WOPGLD_CSS_DIR . '/wopgld-responsive.css', false, WOPGLD_VERSION );


            if ( class_exists( 'WooCommerce' ) ) {
                global $woocommerce;
                wp_enqueue_script( 'wc-add-to-cart-variation', $woocommerce -> plugin_url() . '/assets/js/frontend/add-to-cart-variation.js', array( 'jquery', 'wp-util' ), '1.6', true );
            }
            wp_enqueue_script( 'wopgld-isotope-script', WOPGLD_JS_DIR . '/isotope.js', array( 'jquery' ), WOPGLD_VERSION );
            wp_enqueue_script( 'wopgld-bxslider-script', WOPGLD_JS_DIR . '/jquery.bxslider.js', array( 'jquery' ), WOPGLD_VERSION );
            wp_enqueue_script( 'wopgld-imageloaded-script', WOPGLD_JS_DIR . '/imagesloaded.min.js', array( 'jquery' ), WOPGLD_VERSION );
            wp_enqueue_script( 'wopgld-scroll-script', WOPGLD_JS_DIR . '/jquery.mCustomScrollbar.concat.min.js', array( 'jquery' ), WOPGLD_VERSION );

            if ( class_exists( 'WooCommerce' ) ) {
                $js_list = array( 'jquery', 'wp-util', 'wopgld-imageloaded-script', 'wopgld-isotope-script', 'wopgld-bxslider-script', 'wopgld-scroll-script', 'wc-add-to-cart-variation' );
            }
            wp_enqueue_script( 'wopgld-frontend-script', WOPGLD_JS_DIR . '/wopgld-frontend.js', $js_list, WOPGLD_VERSION );

            $frontend_ajax_nonce = wp_create_nonce( 'wopgld-frontend-ajax-nonce' );
            $frontend_ajax_object = array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'ajax_nonce' => $frontend_ajax_nonce );
            wp_localize_script( 'wopgld-frontend-script', 'wopgld_frontend_js_params', $frontend_ajax_object );
            if ( class_exists( 'WooCommerce' ) ) {
                global $woocommerce;
                $translation_array = array( 'templateUrl' => $woocommerce -> plugin_url() );
//after wp_enqueue_script
                wp_localize_script( 'wopgld-frontend-script', 'wopgld_object_name', $translation_array );
            }
        }

//register woo product grid/list design custom post type
        function wopgld_register_post_type(){
            include('inc/admin/register/wopgld-register-post.php');
            register_post_type( 'woo_product_design', $args );
        }

//adding Blog metabox
        function wopgld_add_blog_metabox(){
            add_meta_box( 'wopgld_add_blog', __( 'Product Grid/List Design', WOPGLD_TD ), array( $this, 'wopgld_add_blog_callback' ), 'woo_product_design', 'normal', 'high' );
        }

        /*
         * callback function for Blog manager metabox
         */

        function wopgld_add_blog_callback( $post ){
            wp_nonce_field( basename( __FILE__ ), 'wopgld_product_nonce' );
            include('inc/admin/wopgld-blog-meta.php');
        }

//save the metabox
        function wopgld_meta_save( $post_id ){

// Checks save status
            $is_autosave = wp_is_post_autosave( $post_id );
            $is_revision = wp_is_post_revision( $post_id );

            $is_valid_nonce = ( isset( $_POST[ 'wopgld_product_nonce' ] ) && wp_verify_nonce( $_POST[ 'wopgld_product_nonce' ], basename( __FILE__ ) ) ) ? 'true' : 'false';
// Exits script depending on save status
            if ( $is_autosave || $is_revision || ! $is_valid_nonce ) {
                return;
            }

            if ( isset( $_POST[ 'wopgld_option' ] ) ) {

                $wopgld_array = ( array ) $_POST[ 'wopgld_option' ];

                $val = $this -> wopgld_sanitize_array( $wopgld_array );
// save data
                update_post_meta( $post_id, 'wopgld_option', $val );
            }

            return;
        }

        function print_array( $array ){
            echo '<pre>';
            print_r( $array );
            echo '</pre>';
        }

        /*
         * Ajax call for slider images
         */

        function wopgld_slider_images(){
            global $wpdb;
            include( 'inc/admin/wopgld-slider-image.php' );
            die();
        }

        function wopgld_selected_taxonomy_terms(){
            global $wpdb;
            include( 'inc/ajax/fetch-terms.php' );
            die();
        }

        function wopgld_hierarchy_terms(){
            global $wpdb;
            include( 'inc/ajax/hierarchy-terms.php' );
            die();
        }

        function wopgld_add_meta_condition(){
            global $wpdb;
            include( 'inc/ajax/add-meta.php' );
            die();
        }

        function wopgld_add_tax_condition(){
            global $wpdb;
            include( 'inc/ajax/add-tax.php' );
            die();
        }

        function wopgld_filter_tax_terms(){
            global $wpdb;
            include( 'inc/ajax/filter-tax.php' );
            die();
        }

        /*
         * Generate random key string
         */

        function wopgld_generate_random_string( $length ){
            $string = '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
            $random_string = '';
            for ( $i = 1; $i <= $length; $i ++ ) {
                $random_string .= $string[ rand( 0, 61 ) ];
            }
            return $random_string;
        }

        function wopgld_generate_shortcode( $atts, $content = null ){

            ob_start();
            include('inc/frontend/wopgld-frontend.php');
            $blog = ob_get_contents();
            ob_end_clean();
            return $blog;
        }

        /*
         * Shortcode Usage Metabox
         */

        function wopgld_shortcode_usage_metabox(){
            add_meta_box( 'wopgld_shortcode_usage_option', __( 'Product Grid/List Design Usages', WOPGLD_TD ), array( $this, 'wopgld_shortcode_usage' ), 'woo_product_design', 'side', 'default' );
        }

        function wopgld_shortcode_usage( $post ){

            wp_nonce_field( basename( __FILE__ ), 'wopgld_shortcode_usage_option_nonce' );
            include('inc/admin/settings/wopgld-usages.php');
        }

//returns all the terms for category dropdown as options
        function wopgld_fetch_category_list( $taxonomy, $term_id ){

            $option_html = "";

            $taxonomies_array[] = $taxonomy;
            $terms = get_terms( $taxonomy, array( 'hide_empty' => false ) );
//die( $terms );
            $categoryHierarchy = array();
            $this -> wopgld_sort_terms_hierarchicaly( $terms, $categoryHierarchy );
            if ( count( $categoryHierarchy ) > 0 ) { //condition check if the taxonomy has atleast single term
                $terms_exclude = array();
                $option_html .= $this -> wopgld_print_option( $categoryHierarchy, 1, '', '', $term_id );
            }

            return $option_html;
        }

        function wopgld_sort_terms_hierarchicaly( Array &$cats, Array &$into, $parentId = 0 ){
            foreach ( $cats as $i => $cat ) {
                if ( $cat -> parent == $parentId ) {
                    $into[ $cat -> term_id ] = $cat;
                    unset( $cats[ $i ] );
                }
            }

            foreach ( $into as $topCat ) {
                $topCat -> children = array();
                $this -> wopgld_sort_terms_hierarchicaly( $cats, $topCat -> children, $topCat -> term_id );
            }
        }

        function wopgld_print_option( $terms, $hierarchical = 1, $form = '', $field_title = '', $selected_term = array() ){
            foreach ( $terms as $term ) {
                $space = $this -> wopgld_check_parent( $term );
                $option_value = $term -> term_id;
                if ( is_array( $selected_term ) ) {
                    $selected = (in_array( $option_value, $selected_term )) ? 'selected="selected"' : '';
                } else {
                    $selected = ($selected_term == $option_value) ? 'selected="selected"' : '';
                }

                $form .= '<option value="' . $option_value . '" ' . $selected . '>' . $space . $term -> name . '</option>';


                if ( ! empty( $term -> children ) ) {

                    $form .= $this -> wopgld_print_option( $term -> children, $hierarchical, '', $field_title, $selected_term );
                }
            }
            return $form;
        }

        function wopgld_check_parent( $term, $space = '' ){
            if ( is_object( $term ) ) {
                if ( $term -> parent != 0 ) {
                    $space .= str_repeat( '&nbsp;', 2 );
                    $parent_term = get_term_by( 'id', $term -> parent, $term -> taxonomy );
// var_dump($space);
                    $space .= $this -> wopgld_check_parent( $parent_term, $space );
                }
            }

            return $space;
        }

        function wopgld_print_checkbox( $terms, $form = '', $field_title = '', $selected_term = array() ){
            foreach ( $terms as $term ) {
                $space = $this -> wopgld_check_parent( $term );
                $option_value = $term -> slug;
                if ( is_array( $selected_term ) ) {
                    $checked = (in_array( $option_value, $selected_term )) ? 'checked="checked"' : '';
                } else {
                    $checked = ($selected_term == $option_value) ? 'checked="checked"' : '';
                }
                $form .= '<label class="wopgld-checkbox-label">' . $space . '<input type="checkbox" name="' . $field_title . '[]"  value="' . $option_value . '" ' . $checked . '/>' . $term -> name . '</label>';

                if ( ! empty( $term -> children ) ) {

                    $form .= $this -> wopgld_print_checkbox( $term -> children, '', $field_title, $selected_term );
                }
            }

            return $form;
        }

        /*
         * Redirect function for view count
         */

        function wopgld_get_post_view( $postID ){
            $count_key = 'post_views_count';
            $count = get_post_meta( $postID, $count_key, true );
            if ( $count == '' ) {
                delete_post_meta( $postID, $count_key );
                add_post_meta( $postID, $count_key, '0' );

                return '0 View';
            }

            return $count . ' Views';
        }

        function wopgld_set_post_view( $postID ){
            $count_key = 'post_views_count';
            $count = ( int ) get_post_meta( $postID, $count_key, true );
            if ( $count < 1 ) {
                delete_post_meta( $postID, $count_key );
                add_post_meta( $postID, $count_key, '0' );
            } else {
                $count ++;
                update_post_meta( $postID, $count_key, ( string ) $count );
            }
        }

        /*
         * Preview page
         */

        function wopgld_preview_page( $post, $link ){

            if ( get_post_type() == 'woo_product_design' ) {
                $post_status = get_post_status();
                if ( $post_status != 'auto-draft' ) {
                    $post_id = get_the_ID();
                    $link = site_url( '?woo_product_design_preview=true&blog_id=' . $post_id );
                    return $link;
                }
            } else {
                $post = get_post( get_the_ID() );


                $args = array(
                    'p' => $post -> ID
                    , 'preview' => 'true'
                );
                return add_query_arg( $args, home_url() );
// exit();
            }
        }

        /**
         * Sanitizes Multi Dimensional Array
         * @param array $array
         * @param array $sanitize_rule
         * @return array
         *
         * @since 1.0.0
         */
        function wopgld_sanitize_array( $array = array(), $sanitize_rule = array() ){
            if ( ! is_array( $array ) || count( $array ) == 0 ) {
                return array();
            }

            foreach ( $array as $k => $v ) {
                if ( ! is_array( $v ) ) {

                    $default_sanitize_rule = (is_numeric( $k )) ? 'html' : 'text';
                    $sanitize_type = isset( $sanitize_rule[ $k ] ) ? $sanitize_rule[ $k ] : $default_sanitize_rule;
                    $array[ $k ] = $this -> wopgld_sanitize_value( $v, $sanitize_type );
                }
                if ( is_array( $v ) ) {
                    $array[ $k ] = $this -> wopgld_sanitize_array( $v, $sanitize_rule );
                }
            }

            return $array;
        }

        /**
         * Sanitizes Value
         *
         * @param type $value
         * @param type $sanitize_type
         * @return string
         *
         * @since 1.0.0
         */
        function wopgld_sanitize_value( $value = '', $sanitize_type = 'text' ){
            switch ( $sanitize_type ) {
                case 'html':
                    $allowed_html = wp_kses_allowed_html( 'post' );
                    return wp_kses( $value, $allowed_html );
                    break;
                default:
                    return sanitize_text_field( $value );
                    break;
            }
        }

        /*
         * pagination
         */

        function wopgld_pagination_action(){
            include('inc/frontend/wopgld-pagination-query.php');
            die();
        }

        function wopgld_preview_blog(){
            if ( isset( $_GET[ 'woo_product_design_preview' ], $_GET[ 'blog_id' ] ) && $_GET[ 'woo_product_design_preview' ] && is_user_logged_in() ) {
                include(WOPGLD_PATH . 'inc/frontend/wopgld-preview.php');
                die();
            }
        }

        /*
         * Adding Submenu page
         */

        function wopgld_register_about_us_page(){
            add_submenu_page(
                    'edit.php?post_type=woo_product_design', __( 'About Us', WOPGLD_TD ), __( 'About Us', WOPGLD_TD ), 'manage_options', 'wopgld-about-us', array( $this, 'wopgld_about_callback' ) );
        }

        function wopgld_about_callback(){

            include('inc/admin/wopgld-about-page.php');
        }

        function wopgld_remove_row_actions( $actions ){
            if ( get_post_type() == 'woo_product_design' ) { // choose the post type where you want to hide the button
                unset( $actions[ 'view' ] ); // this hides the VIEW button on your edit post screen
                unset( $actions[ 'inline hide-if-no-js' ] );
            }
            return $actions;
        }

        /* Add custom column to post list */

        function wopgld_columns_head( $columns ){
            $columns[ 'shortcodes' ] = __( 'Shortcodes', WOPGLD_TD );
            $columns[ 'template' ] = __( 'Template Include', WOPGLD_TD );
            return $columns;
        }

        function wopgld_columns_content( $column, $post_id ){

            if ( $column == 'shortcodes' ) {
                $id = $post_id;
                ?>
                <textarea style="resize: none;" rows="2" cols="20" readonly="readonly">[wopgld id="<?php echo $post_id; ?>"]</textarea><?php
            }
            if ( $column == 'template' ) {
                $id = $post_id;
                ?>
                <textarea style="resize: none;" rows="2" cols="41" readonly="readonly">&lt;?php echo do_shortcode("[wopgld id='<?php echo $post_id; ?>']"); ?&gt;</textarea><?php
            }
        }

        /*
         * Remove view and preview from wp blog post
         */

        function wopgld_posttype_admin_css(){
            global $post_type;
            $post_types = array(
                /* set post types */
                'woo_product_design'
            );
            if ( in_array( $post_type, $post_types ) )
                echo '<style type="text/css">#view-post-btn, .updated a,#screen-meta-links .screen-meta-toggle
                {display: none;}</style>';
        }

        function wopgld_widget_register(){
            register_widget( 'wopgld_Widget' );
        }

// retrieves the attachment ID from the file URL
        function wopgld_get_image_id( $image_url ){
            global $wpdb;
            $query = "SELECT ID FROM {$wpdb -> posts} WHERE guid='$image_url'";
            $id = $wpdb -> get_var( $query );
            return $id;
        }

        function wopgld_banner_settings(){
            add_meta_box( 'wopgld_banner_settings', __( 'WOO Product Grid-List Banner/Ribbon Settings', WOPGLD_TD ), array( $this, 'wopgld_banner_callback' ), 'product', 'normal', 'core' );
        }

        function wopgld_banner_callback(){
            wp_nonce_field( basename( __FILE__ ), 'wopgld_product_nonce' );
            include('inc/admin/fields/wopgld-banner.php');
        }

        function wopgld_button_settings(){

            add_meta_box( 'wopgld_button_settings', __( 'WOO Product Grid/List Settings', WOPGLD_TD ), array( $this, 'wopgld_button_callback' ), 'product', 'normal', 'core' );
        }

        function wopgld_button_callback(){
            wp_nonce_field( basename( __FILE__ ), 'wopgld_product_nonce' );
            include('inc/admin/fields/button-settings.php');
        }

        function wopgld_fetch_category( $post, $category ){
            $id = get_the_ID();
            $categories = get_the_terms( $id, $category );
            $separator = ' ';
            $output = '';

            if ( ! empty( $categories ) ) {
                foreach ( $categories as $category ) {
                    $output .= '<a href="' . esc_url( get_category_link( $category -> term_id ) ) . '" alt="' . esc_attr( sprintf( __( 'View all posts in %s', WOPGLD_TD ), $category -> name ) ) . '">' . esc_html( $category -> name ) . '</a>' . $separator;
                }
                return trim( $output, $separator );
            }
        }

        function wopgld_fetch_content( $post, $excerpt_length ){
            $id = get_the_ID();
            if ( has_excerpt( $id ) ) {
                return substr( get_the_excerpt(), 0, $excerpt_length ) . '...';
            } else {
                return wp_trim_words( strip_tags( strip_shortcodes( get_the_content() ) ), $excerpt_length, '...' );
            }
        }

        function wopgld_image_size( $post, $size ){
            $src = wp_get_attachment_image_src( get_post_thumbnail_id( $post -> ID ), $size, false );
            return $src;
        }

        function wopgld_filter_category_block( $post, $taxonomy ){
            $categories = get_the_terms( $post, $taxonomy );
            $separator = ' ';
            $output = '';
            if ( ! empty( $categories ) ) {
                foreach ( $categories as $category ) {
                    $output .= ' wopgld-filter-cat-' . esc_html( $category -> slug ) . $separator;
                }
                return trim( $output, $separator );
            }
        }

        function wopgld_wishlist_button(){
            if ( class_exists( 'YITH_WCWL' ) ) {
                global $product, $yith_wcwl;
                $id = get_the_ID();
                $default_wishlists = is_user_logged_in() ? YITH_WCWL() -> get_wishlists( array( 'is_default' => true ) ) : false;
                if ( ! empty( $default_wishlists ) ) {
                    $default_wishlist = $default_wishlists[ 0 ][ 'ID' ];
                } else {
                    $default_wishlist = false;
                }
                $wishlist_url = YITH_WCWL() -> get_wishlist_url();
                ?>
                <div class="yith-wcwl-add-to-wishlist add-to-wishlist-<?php echo $id; ?>">
                    <div class="yith-wcwl-add-button show" style="display:block">
                        <a  href="<?php echo esc_url( add_query_arg( 'add_to_wishlist', $id ) ); ?>" rel="nofollow" data-product-id="<?php echo $id; ?>" data-product-type="variable" class="add_to_wishlist">
                            <i class="wopgld-heart fa fa-heart-o"></i>
                            <img src="<?php echo WOPGLD_IMG_DIR; ?>/wpspin_light.gif" class="ajax-loading" alt="loading" style="display:none !important;">
                            <span class="ts-tooltip button-tooltip"><?php _e( 'Add to wishlist', WOPGLD_TD ); ?></span>
                        </a>
                    </div>
                    <div class="yith-wcwl-wishlistaddedbrowse hide" style="display:none;">
                        <a href="<?php echo esc_url( $wishlist_url ); ?>" rel="nofollow">
                            <i class="fa fa-check" aria-hidden="true"></i><span class="ts-tooltip button-tooltip"><?php _e( 'Browse Wishlist', WOPGLD_TD ); ?></span> </a>
                    </div>
                    <div class="yith-wcwl-wishlistexistsbrowse hide" style="display:none">
                        <a href="<?php echo esc_url( $wishlist_url ); ?>" rel="nofollow">
                            <i class="fa fa-check" aria-hidden="true"></i><span class="ts-tooltip button-tooltip"><?php _e( 'Browse Wishlist', WOPGLD_TD ); ?></span> </a>
                    </div>
                    <div style="clear:both"></div>
                    <div class="yith-wcwl-wishlistaddresponse"></div>
                </div>
                <?php
                return;
            }
        }

//save the extra field metabox values
        function wopgld_advance_field_save( $post_id ){

// Checks save status
            $is_autosave = wp_is_post_autosave( $post_id );
            $is_revision = wp_is_post_revision( $post_id );
            $is_valid_nonce = ( isset( $_POST[ 'wopgld_product_nonce' ] ) && wp_verify_nonce( $_POST[ 'wopgld_product_nonce' ], basename( __FILE__ ) ) ) ? 'true' : 'false';
// Exits script depending on save status
            if ( $is_autosave || $is_revision || ! $is_valid_nonce ) {
                return;
            }
            if ( isset( $_POST[ 'wopgld_advance_option' ] ) ) {

                $wopgld_advance = ( array ) $_POST[ 'wopgld_advance_option' ];

                $advance_field = $this -> wopgld_sanitize_array( $wopgld_advance );
// save data
                update_post_meta( $post_id, 'wopgld_advance_option', $advance_field );
            }
            return;
        }

        function wopgld_filter_category( $post_id, $taxonomy ){
            $categories = get_the_terms( $post_id, $taxonomy );
            $separator = ' ';
            $output = '';
            if ( ! empty( $categories ) ) {
                foreach ( $categories as $category ) {
                    $output .= 'wopgld-filter-cat-' . esc_html( $category -> slug ) . $separator;
                }
                echo 'wopgld-filter-all ' . trim( $output, $separator );
            }
            return;
        }

        function wopgld_add_new_image_size(){

            add_image_size( 'wopgld-frame-image', 478, 300, true );
        }

        function wopgld_add_lightbox_footer(){
            include(WOPGLD_PATH . '/inc/frontend/data/attribute-wrap.php');
        }

        /*
         * Inline view
         */

        function wopgld_view_lightbox(){
            global $wpdb;
            include (WOPGLD_PATH . '/inc/frontend/data/lightbox/ajax-content.php');
            die();
        }

        /*
         * Woocommerce Variable Attribute
         */

        function wopgld_variable_attribute(){
            global $wpdb;
            include (WOPGLD_PATH . '/inc/frontend/data/lightbox/variable-content.php');
            die();
        }

//        function wc_ajax_add_to_cart_variable_add_section( $sections ){
//
//            $sections[ 'wc_ajax_add_to_cart_variable' ] = __( 'WC Ajax for Variable Products', WOPGLD_TD );
//            return $sections;
//        }
//        function wc_ajax_add_to_cart_variable_all_settings( $settings, $current_section ){
//
//            /**
//             * Check the current section is what we want
//             * */
//            if ( $current_section == 'wc_ajax_add_to_cart_variable' ) {
//
//                $settings_slider = array();
//
//// Add Title to the Settings
//                $settings_slider[] = array( 'name' => __( 'WC Ajax for Variable Products Settings', WOPGLD_TD ), 'type' => 'title', 'desc' => __( 'The following options are used to configure WC Ajax for Variable Products', WOPGLD_TD ), 'id' => 'wc_ajax_add_to_cart_variable' );
//
//// Add first checkbox option
//                $settings_slider[] = array(
//                    'name' => __( 'Add Selection option to Category Page', WOPGLD_TD ),
//                    'desc_tip' => __( 'This will automatically insert variable selection options on product Category Archive Page', WOPGLD_TD ),
//                    'id' => 'wc_ajax_add_to_cart_variable_category_page',
//                    'type' => 'checkbox',
//                    'css' => 'min-width:300px;',
//                    'desc' => __( 'Enable Varition select option on Category Archive page', WOPGLD_TD ),
//                );
//
//                $settings_slider[] = array( 'type' => 'sectionend', 'id' => 'wc_ajax_add_to_cart_variable' );
//
//                return $settings_slider;
//
//                /**
//                 * If not, return the standard settings
//                 * */
//            } else {
//
//                return $settings;
//            }
//        }

        /*
         * Add to cart for variable product attributes
         */

        function woocommerce_add_to_cart_variable_rc_callback(){

            ob_start();
            $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST[ 'product_id' ] ) );
            $quantity = empty( $_POST[ 'quantity' ] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST[ 'quantity' ] );

            $variation_id = isset( $_POST[ 'variation_id' ] ) ? absint( $_POST[ 'variation_id' ] ) : '';
            $variation = ! empty( $_POST[ 'variation' ] ) ? ( array ) $_POST[ 'variation' ] : '';

            $passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity, $variation_id, $variation, $cart_item_data );

            if ( $passed_validation && WC() -> cart -> add_to_cart( $product_id, $quantity, $variation_id, $variation ) ) {
                do_action( 'woocommerce_ajax_added_to_cart', $product_id );
                if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
                    wc_add_to_cart_message( $product_id );
                }

// Return fragments
                WC_AJAX::get_refreshed_fragments();
            } else {
                $this -> json_headers();

// If there was an error adding to the cart, redirect to the product page to show any errors
                $data = array(
                    'error' => true,
                    'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
                );
                echo json_encode( $data );
            }
            die();
        }

        /*
         * Adding Common Settings Page
         */

//        function wopgld_register_settings_page(){
//            add_submenu_page(
//                    'edit.php?post_type=woo_product_design', __( 'Settings', WOPGLD_TD ), __( 'Settings', WOPGLD_TD ), 'manage_options', 'wopgld-common-settings', array( $this, 'wopgld_setting_callback' ) );
//        }
//
//        function wopgld_setting_callback(){
//
//            include('inc/admin/register/settings.php');
//        }

        /**
         * Add form value in database
         *
         * @since 1.0.1
         * */
        function wopgld_save_form_settings(){
            if ( isset( $_POST[ 'wopgld_form_nonce_field' ] ) && wp_verify_nonce( $_POST[ 'wopgld_form_nonce_field' ], 'wopgld_form_nonce' ) ) {

                if ( isset( $_POST[ 'wopgld_common_settings' ] ) ) {
                    $wopgld_common = ( array ) $_POST[ 'wopgld_common_settings' ];
// sanitize array
                    $wopgld_common_option = array_map( 'sanitize_text_field', $wopgld_common );
// save data
                    update_option( 'wopgld_common_settings', $wopgld_common_option );
                }
            }
            wp_redirect( admin_url( 'admin.php?page=wopgld-common-settings&message=1' ) );
            exit;
        }

        function wopgld_vc_integrate_widget(){
            include('inc/admin/wopgld-vc-elements.php');
        }

    }

//class terminations

    $wopgld_obj = new WOPGLD_Class();
}//class exist check close

include('inc/admin/register/wopgld-widget.php');

